//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 05: OpenMp
//
//  Description: Simple examples  in openMP
//  	dice02.c:    A trusted dice ??
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc dice02.c -o dice02
Executing:	./dice02

Output in my laptop:

0 9998142
1 9999581
2 10000326
3 10003300
4 9997641
5 10001010

real	0m9.457s
user	0m29.284s
sys	0m39.956s

*/
//************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>

#define N	60000000

// **************************************************************
int main(void)
{
	unsigned int x[6]={0,0,0,0,0,0} ;

#pragma omp parallel for num_threads(8)
	for( int i = 0 ; i < N ; i++ ) {
	unsigned int k = rand()%6 ;
#pragma omp atomic
		x[k]++ ;
}

	for( int i = 0 ; i < 6 ; i++ )
		printf( "%d %u\n", i, x[i] ) ;

	return 0 ;
}
