//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 05: OpenMp
//
//  Description: Simple examples  in openMP
//  	dice03.c:    A trusted dice, using custom parallel random generator
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc dice03.c -o dice03
Executing:	./dice03

Output in my laptop:

0 10002264
1 9998416
2 9996976
3 9994296
4 10000760
5 10007288

real	0m1.623s
user	0m12.846s
sys	0m0.017s

*/
//************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>

#define N	60000000

unsigned int seed = 666999666 ;  // random number seed

// **************************************************************

unsigned int x[8][6] ;

// **************************************************************
int main(void)
{

#pragma omp threadprivate(seed)
#pragma omp parallel for num_threads(8) schedule(static,1000000)
	for( int i = 0 ; i < N ; i++ ) {
		seed = seed * 1103515245 + 12345;
		x[omp_get_thread_num()][seed%6]++ ;
	}

	for( int i = 0 ; i < 6 ; i++ ) {
		int sum = 0 ;
		for( int j = 0 ; j < 8 ; j++ )
			sum += x[j][i] ;
		printf( "%d %u\n", i, sum ) ;
	}
	return 0 ;
}
