//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 05: OpenMp
//
//  Description: Simple examples  in openMP
//  	Pi02.c: Estimation of pi
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc Pi02.c -o Pi02 -fopenmp
Executing:	./Pi02
pi= 3.14159266567504192

real	0m7.558s
user	0m7.557s
sys	0m0.001s


*/
//************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>


#define N 1000000000

// **************************************************************
int main(void)
{
	double sum = 0 ;
	double x,step ;

	step = 1.0/N ;
	x = 0.0 ;

	for( int i = 0 ; i < N ; i++, x+=step )
		sum += sqrt( 1.0 - x*x ) ;

	printf( "pi=%20.17lf\n", 4.0 * sum * step ) ;
	return 0 ;
}
